<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/Foreach.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/Foreach.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 31 juli 2009, 21:21</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef FOREACH_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define FOREACH_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Object.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstddef&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">struct </span>foreach_container_base {
<a name="l00028"></a>00028 };
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00031"></a>00031 <span class="keyword">struct </span>foreach_container : <span class="keyword">public</span> foreach_container_base {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033     <span class="keyword">inline</span> foreach_container(<span class="keyword">const</span> T &amp; t) : c(t), brk(0), i(c.begin()),
<a name="l00034"></a>00034     e(c.end()) {
<a name="l00035"></a>00035     };
<a name="l00036"></a>00036     <span class="keyword">const</span> T c;
<a name="l00037"></a>00037     <span class="keyword">mutable</span> <span class="keywordtype">int</span> brk;
<a name="l00038"></a>00038     <span class="keyword">mutable</span> <span class="keyword">typename</span> T::const_iterator i, e;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040     <span class="keyword">inline</span> <span class="keywordtype">bool</span> condition()<span class="keyword"> const </span>{
<a name="l00041"></a>00041         <span class="keywordflow">return</span> (!brk++ &amp;&amp; i != e);
<a name="l00042"></a>00042     }
<a name="l00043"></a>00043 };
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00046"></a>00046 <span class="keyword">inline</span> T* foreach_pointer(<span class="keyword">const</span> T&amp;) {
<a name="l00047"></a>00047     <span class="keywordflow">return</span> Sylph::null;
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00051"></a>00051 <span class="keyword">inline</span> foreach_container&lt;T&gt; foreach_container_create(<span class="keyword">const</span> T&amp; t) {
<a name="l00052"></a>00052     <span class="keywordflow">return</span> foreach_container&lt;T &gt; (t);
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a>00056 <span class="keyword">inline</span> <span class="keyword">const</span> foreach_container&lt;T&gt;* foreach_cast(
<a name="l00057"></a>00057         <span class="keyword">const</span> foreach_container_base&amp; base, <span class="keyword">const</span> T&amp;) {
<a name="l00058"></a>00058     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keyword">const </span>foreach_container&lt;T*&gt; *<span class="keyword">&gt;</span> (base);
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="preprocessor">#define sforeach(variable, container) \</span>
<a name="l00063"></a>00063 <span class="preprocessor">for (const ::foreach_container_base &amp;_container_ = \</span>
<a name="l00064"></a>00064 <span class="preprocessor">    ::foreach_container_create(container); ::foreach_cast(_container_, \</span>
<a name="l00065"></a>00065 <span class="preprocessor">    true ? 0 : ::foreach_pointer(container))-&gt;condition(); \</span>
<a name="l00066"></a>00066 <span class="preprocessor">    ++::foreach_cast(_container_, true ? 0 : \</span>
<a name="l00067"></a>00067 <span class="preprocessor">    ::foreach_pointer(container))-&gt;i) \</span>
<a name="l00068"></a>00068 <span class="preprocessor">    for (variable = *::foreach_cast(_container_, true ? 0 : \</span>
<a name="l00069"></a>00069 <span class="preprocessor">            ::foreach_pointer(container))-&gt;i; ::foreach_cast(_container_, \</span>
<a name="l00070"></a>00070 <span class="preprocessor">            true ? 0 : ::foreach_pointer(container))-&gt;brk; \</span>
<a name="l00071"></a>00071 <span class="preprocessor">            --::foreach_cast(_container_, true ? 0 : \</span>
<a name="l00072"></a>00072 <span class="preprocessor">            ::foreach_cast(container))-&gt;brk)</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074 <span class="preprocessor">#endif  </span><span class="comment">/* FOREACH_H_ */</span>
<a name="l00075"></a>00075 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
